=== modified file 'bzrlib/_known_graph_py.py'
--- bzrlib/_known_graph_py.py	2009-08-25 18:42:19 +0000
+++ bzrlib/_known_graph_py.py	2009-08-25 18:45:40 +0000
@@ -251,10 +251,9 @@
                              reverse=True)
             while pending:
                 node = pending.pop()
-                # TODO: test ghosts
-                # if node.parent_keys is None:
-                #     # Ghost node, skip it
-                #     continue
+                if node.parent_keys is None:
+                    # Ghost node, skip it
+                    continue
                 result.append(node.key)
                 for parent_key in sorted(node.parent_keys, reverse=True):
                     parent_node = self._nodes[parent_key]

=== modified file 'bzrlib/_known_graph_pyx.pyx'
--- bzrlib/_known_graph_pyx.pyx	2009-08-25 18:42:19 +0000
+++ bzrlib/_known_graph_pyx.pyx	2009-08-25 18:45:40 +0000
@@ -473,10 +473,8 @@
             pending = _sort_list_nodes(nodes, 1)
             while pending:
                 node = pending.pop()
-                # TODO: test ghosts
-                # if node.parent_keys is None:
-                #     # Ghost node, skip it
-                #     continue
+                if node.parents is None:
+                    continue
                 result.append(node.key)
                 parents = _sort_list_nodes(list(node.parents), 1)
                 for pos from 0 <= pos < PyList_GET_SIZE(parents):

=== modified file 'bzrlib/tests/test__known_graph.py'
--- bzrlib/tests/test__known_graph.py	2009-08-25 18:42:19 +0000
+++ bzrlib/tests/test__known_graph.py	2009-08-25 18:45:40 +0000
@@ -813,3 +813,7 @@
                            'e':('b', 'c', 'd'),
                            'f':('d', 'Z'),
                            })
+
+    def test_skip_ghost(self):
+        self.assertSorted(['b', 'c', 'a'],
+                          {'a':(), 'b':('a', 'ghost'), 'c':('a',)})

